//
//  SAViewController.m
//  Test
//
//  Created by Sian on 14/11/6.
//  Copyright (c) 2014年 www.yusian.com All rights reserved.
//

#import "SAViewController.h"

@interface SAViewController ()

@end

@implementation SAViewController

- (void)viewDidLoad
{
    [super viewDidLoad];

    // 初始化自定义队列
    self.myQueue = [[NSOperationQueue alloc] init];
    
    // Block队列操作
    [self blockOperation];
    
    // Invocation队列操作
    // [self invocationOperation];
    
}

#pragma mrak 1、Block队列操作
- (void)blockOperation
{
    // 循环10次添加10个任务到自定义队列
    for (int i = 0; i < 10; i++) {
        
        // 创建一个操作任务，不需要关心串行并行等问题
        NSBlockOperation *blockOp = [NSBlockOperation blockOperationWithBlock:^{
            
            // 每执行一次任务，输出该任务的添加序号及线程对象
            NSLog(@"第 %d 次 - %@", i, [NSThread currentThread]);
        }];
        
        // 将任务添加到自定义队列中，默认将异步并行执行
        [self.myQueue addOperation:blockOp];
        
        // 将任务添加到主队列中，即在主线程中执行
        // [[NSOperationQueue mainQueue] addOperation:blockOp];
    }
}

#pragma mark 2、invocation队列操作
- (void)invocationOperation
{
    for (int i = 0; i < 10; i++) {
        
        // 与NSBlockOperation类似，唯一不同的是这里通过调用方法实现队列执行体
        NSInvocationOperation *invocationOp = [[NSInvocationOperation alloc] initWithTarget:self selector:@selector(operationAction:) object:@(i)];
        
        [self.myQueue addOperation:invocationOp];
        
        // [[NSOperationQueue mainQueue] addOperation:invocationOp];
        
    }
}

#pragma mark 调用方法
- (void)operationAction:(id)obj
{
    NSLog(@"第 %d 次 - %@", [obj intValue], [NSThread currentThread]);
}
@end
